////////////////////////////////////////////////////////////////////////////////
#byte       timer0l             =0xfd6
#byte       intcon              =0xff2
#bit        tmr0if              =intcon.2
#byte       txreg               =0xfad
#byte       txsta               =0xfac
#bit        trmt                =txsta.1    //1=ready for next byte
////////////////////////////////////////////////////////////////////////////////
#define     leg_an              b0lat
#define     leg_ap              b1lat
#define     leg_bn              b2lat
#define     leg_bp              b3lat
#define     lcd_detect          c2pin  
#define     button_left         a4pin
#define     button_right        a2pin
////////////////////////////////////////////////////////////////////////////////
unsigned    int1                start_cycle;
unsigned    int32               cycle_counter;
unsigned    int16               stop_threshold;
unsigned    int16               stop_count;
//------------------------------------------------------------------------------
unsigned    int1                lcd_installed;
//------------------------------------------------------------------------------
unsigned    int16               test_count;
unsigned    int8                t_a_on;
unsigned    int8                t_a_off;
unsigned    int8                t_b_on;
unsigned    int8                t_b_off;
unsigned    int16               last_ab;
unsigned    int16               last_xy;
//------------------------------------------------------------------------------
unsigned    int8                rs232_data[256];
unsigned    int8                rs232_start;
unsigned    int8                rs232_end;
unsigned    int8                lcd_data[256];
unsigned    int8                lcd_start;
unsigned    int8                lcd_end;
////////////////////////////////////////////////////////////////////////////////






////////////////////////////////////////////////////////////////////////////////
void meminit(void){
//------------------------------------------------------------------------------
alat=0b00100000;
blat=0b00001010;
clat=0b11000000;
adir=0b00011111;
bdir=0b00000000;
cdir=0b10000100;
//------------------------------------------------------------------------------
setup_adc_ports(AN0_TO_AN1|VSS_VREF);
setup_adc(ADC_CLOCK_INTERNAL|ADC_TAD_MUL_20);
setup_spi(SPI_SS_DISABLED);
setup_wdt(WDT_OFF);
setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4|RTCC_8_bit);
setup_timer_1(T1_DISABLED);
setup_timer_2(T2_DISABLED,0,1);
setup_comparator(NC_NC_NC_NC);
setup_vref(FALSE);
enable_interrupts(INT_RDA);
enable_interrupts(GLOBAL);
//------------------------------------------------------------------------------
//test control variable initialization
start_cycle=0;
cycle_counter=0;

stop_threshold=make16(read_eeprom(0),read_eeprom(1));
if (stop_threshold>9999)
    stop_threshold=9999;

stop_count=make16(read_eeprom(2),read_eeprom(3));
if (stop_count>9999)
    stop_count=9999;
if (stop_count==0)
    stop_count=1;
    
t_a_on=read_eeprom(4);
if (t_a_on > 99)
    t_a_on = 99;
if (t_a_on == 0)
    t_a_on=1;

t_a_off=read_eeprom(5);
if (t_a_off > 99)
    t_a_off = 99;

t_b_on=read_eeprom(6);
if (t_b_on > 99)
    t_b_on = 99;
if (t_b_on == 0)
    t_b_on=1;

t_b_off=read_eeprom(7);
if (t_b_off > 99)
    t_b_off = 99;

test_count=0;
last_ab=0;
last_xy=0;
//..............................................................................
//buffer pointer initialization
rs232_start=0;
rs232_end=0;
lcd_start=0;
lcd_end=0;
}
////////////////////////////////////////////////////////////////////////////////
