////////////////////////////////////////////////////////////////////////////////
void buffer_rs232 (unsigned int8 data){

rs232_data[rs232_end]=data;
rs232_end++;
}
////////////////////////////////////////////////////////////////////////////////
void buffer_lcd (unsigned int8 data){

lcd_data[lcd_end]=data;
lcd_end++;
}
////////////////////////////////////////////////////////////////////////////////
unsigned int1 systime (void){
unsigned int8 temp;

//this would normally be done by a delay routine
restart_wdt();

//rs232 transmit, trmt=1 means the transmit buffer is empty
if (trmt)
    {
    //if data waiting then send a byte
    if (rs232_start != rs232_end)
        {
        txreg=rs232_data[rs232_start];
        rs232_start++;
        }
    }
    
//lcd write when not busy
if (!lcd_busy())
    {
    //if data waiting then display a byte
    if (lcd_start != lcd_end)
        {
        temp=lcd_data[lcd_start];
        if (temp & 0x80)
            lcd_cmmd(temp);
        else
            lcd_char(temp);
        lcd_start++;
        }
    }

//102.4uS overflow of timer 0, return 1 if tick has elapsed
if (tmr0if)
    {
    tmr0if=0;
    return 1;
    }
else
    return 0;

}
////////////////////////////////////////////////////////////////////////////////
void ab_off(void){
unsigned int8 temp;

temp = blat & 0xf0;
blat = temp | 0x0a;
delay_us(10);
}
////////////////////////////////////////////////////////////////////////////////
void a_on(void){

ab_off();
leg_an=1;
leg_ap=0;

}
////////////////////////////////////////////////////////////////////////////////
void b_on(void){

ab_off();
leg_bn=1;
leg_bp=0;

}
////////////////////////////////////////////////////////////////////////////////
unsigned int1 cycle(void){
unsigned int16 i;
unsigned int16 temp1;
unsigned int16 temp2;

cycle_counter++;
//...............................................
a_on();
set_adc_channel(0);
i=t_a_on * 10;
while(i>0)
    {
    if (systime())
        i--;
    }
temp1=read_adc();
if (lcd_installed)
    {
    buffer_lcd(lcd_line1);
    printf(buffer_lcd,"%08LX",cycle_counter);
    }
printf(buffer_rs232,"!0040,%06LX",cycle_counter);
ab_off();
if (t_a_off >0)
    {
    i=t_a_off * 10;
        while(i>0)
        {
        if (systime())
            i--;
        }
    }
ab_off();
//...............................................
b_on();
set_adc_channel(1);
i=t_b_on * 10;
while(i>0)
    {
    if (systime())
        i--;
    }
temp2=read_adc();
if (lcd_installed)
    {
    buffer_lcd(lcd_line2);
    printf(buffer_lcd,"a%03LXx%03LX",temp1,temp2);
    }
printf(buffer_rs232,",%03LX,%03LX\r\n",temp1,temp2);
ab_off();
if (t_b_off >0)
    {
    i=t_b_off * 10;
        while(i>0)
        {
        if (systime())
            i--;
        }
    }
ab_off();
//...............................................
last_ab=temp1;
last_xy=temp2;

if ((temp1 <= stop_threshold) || (temp2 <= stop_threshold))
    return 1;
else
    return 0;
}
////////////////////////////////////////////////////////////////////////////////
//period    H or L time in mS                                                  /
//count     Cycle count, new command cancels                                   /
//          0 = continuous                                                     /
////////////////////////////////////////////////////////////////////////////////
void pulse_hl_off(void){
unsigned int16 i;
unsigned int1 flag;
unsigned int16 stop_counter=0;

if (test_count==0)
    {
    while(!scmd_ready)
        {
        restart_wdt();
        flag=cycle();
        if (flag)
            stop_counter++;
        if (scmd_ready || (stop_counter >= stop_count) || (!button_right))
            break;
        }
    }
else
    {
    for (i=test_count;i>0;i--)
        {
        restart_wdt();
        flag=cycle();
        if (flag)
            stop_counter++;
        if (scmd_ready || (stop_counter >= stop_count) || (!button_right))
            break;
        }
    }
  
}
////////////////////////////////////////////////////////////////////////////////
void display_count(void){

if (lcd_installed)
    {
    lcd_cmmd(lcd_line1);
    printf(lcd_char,"%08LU",cycle_counter);
    lcd_cmmd(lcd_line2);
    printf(lcd_char,"a%03lUx%03lU",last_ab,last_xy);
    }
}
////////////////////////////////////////////////////////////////////////////////
void reset_count(void){

last_ab=0;
last_xy=0;
cycle_counter=0;

display_count();
}
////////////////////////////////////////////////////////////////////////////////





